// ==============================================================
// Ananke Payload Release Dialog - gives automatic payload
// release for the Ananke LEO tether
//
// Copyright 2008 - Tim Blaxland and Sean Kilpatrick
// ==============================================================

#ifndef ANANKE_PAYLOAD_RELEASE_H
#define ANANKE_PAYLOAD_RELEASE_H

#define STRICT
#define ORBITER_MODULE
#define _CRT_SECURE_NO_DEPRECATE

#include "windows.h"
#include "orbitersdk.h"
#include "resource.h"
#include <stdio.h>
#include "ZTC_CommCodes.h"
#include "ZTCMaths.h"
#include "Ananke.h"


// ==============================================================
// Global constants
// ==============================================================

const double dlgUpdateInterval = 0.1;

// ==============================================================
// Global variables
// ==============================================================

HINSTANCE g_hInst;  // module instance handle
DWORD g_dwCmd;      // custom function identifier
OBJHANDLE g_obj_Ananke; // Ananke object handle
Ananke *g_Ananke; // Ananke vessel interface
double g_oldVVAngle; // Rate of change of angle between velocity vector and local coordinate reference
double dlgUpdateTime;
bool g_ReleaseArmed;


// ==============================================================
// API interface
// ==============================================================

// --------------------------------------------------------------
// This function is called when Orbiter starts or when the module
// is activated.
// --------------------------------------------------------------
DLLCLBK void InitModule (HINSTANCE hDLL);

// --------------------------------------------------------------
// This function is called when Orbiter shuts down or when the
// module is deactivated
// --------------------------------------------------------------
DLLCLBK void ExitModule (HINSTANCE hDLL);

// --------------------------------------------------------------
// This function is called before each time step
// --------------------------------------------------------------
DLLCLBK void opcPreStep (double SimT,double SimDT,double mjd);

// --------------------------------------------------------------
// Open the dialog window
// --------------------------------------------------------------
void OpenDlgClbk (void *context);

// --------------------------------------------------------------
// Close the dialog
// --------------------------------------------------------------
void CloseDlg (HWND hDlg);

// --------------------------------------------------------------
// Windows message handler for the dialog box
// --------------------------------------------------------------
BOOL CALLBACK MsgProc (HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam);

#endif // ANANKE_PAYLOAD_RELEASE_H